/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.TitleDao;
import com.portofolio.dto.TitleDto;
import com.portofolio.entity.Title;
import com.portofolio.entity.vo.TitleId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class TitleService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private TitleDao titleDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(TitleDto titleDto) {
		result.clear();
		TitleId id = new TitleId();
		Integer kdTitle =getIdTerahir(Title.class.getSimpleName());
		id.setKdTitle(kdTitle);
		id.setKdProfile(getKdProfile());
		Title title = CommonUtil.findOne(titleDao, id);
		if (CommonUtil.isNullOrEmpty(title)) {
			title = new Title();
			BeanUtils.copyProperties(titleDto, title);
			title.setNoRec(generateUuid32());
			title.setVersion(1);
			title.setId(id);
			title = titleDao.save(title);
			result.put("title", title);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("title.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(TitleDto titleDto, Integer kdTitle, Integer version) {
		result.clear();
		TitleId id = new TitleId();
		id.setKdTitle(kdTitle);
		id.setKdProfile(getKdProfile());
		Title title = CommonUtil.findOne(titleDao, id);
		if (CommonUtil.isNotNullOrEmpty(title)) {
			if (version < title.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(titleDto, title);
			title.setVersion(version);
			title = titleDao.save(title);
			result.put("title", title);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaTitle,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaTitle)) {
			pageRes = titleDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = titleDao.findAllList(getKdProfile(), namaTitle, statusEnabled, pageReq);
		}
		result.put("title", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdTitle(Integer kdTitle) {
		result.clear();
		result.put("title", titleDao.findByKdTitle(getKdProfile(), kdTitle, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdTitle, Integer version) {
		result.clear();
		TitleId id = new TitleId();
		id.setKdTitle(kdTitle);
		id.setKdProfile(getKdProfile());
		Title title = CommonUtil.findOne(titleDao, id);
		if (CommonUtil.isNotNullOrEmpty(title)) {
			if (version < title.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			title.setStatusEnabled(false);
			title.setVersion(version);
			title = titleDao.save(title);
			result.put("title", title);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
